#include <bits/stdc++.h>
#include <unordered_map>

using namespace std;

int main()
{
    int n,k,sum=0;
    scanf("%d %d",&n , &k);
    unordered_map<int, int> hm;
    stringstream ss;
    string str="";
    int x;
    for(int i=0;i<n;i++){
        scanf("%d",&x);
        hm[x]++;
        if(hm[x] == k){
            sum++;
            ss << x;
            str = str + ss.str() + " ";
            ss.str("");
        }
    }
    if(sum>0){
        printf("%d\n",sum);
        cout << str;
        printf("\n");
    }
    else{
        printf("0\n\n");
    }
}